# Tutorial

:project Tutorial: Primo progetto

## Finestra del progetto

:position 30,30,40,40

:overlay

### Finestra del progetto

La finestra del progetto si apre quando si crea un nuovo progetto o si apre uno dei
progetti esistenti. Qui è dove programmi, provi, crei sprites,
mappe e imposti tutti i dettagli del tuo progetto.

## Navigazione

### Navigazione nel progetto

Una colonna di icone si trova sul lato sinistro dello schermo. Permette di
aprire rapidamente l'editor di codice, l'editor di sprite, le mappe, la documentazione, le impostazioni e le opzioni di pubblicazione
del tuo progetto.

:highlight #projectview .sidemenu ul


## Sezione codice

### Codifica ed esecuzione

Clicca su **Codice** per aprire la prima sezione.

:highlight #projectview .sidemenu #menuitem-code

:auto


## Sezione codice 2

:navigate projects.code

### Codifica ed esecuzione

In questa sezione puoi creare il tuo programma, eseguire la tua applicazione, testare e fare il debug.
Il lato sinistro dello schermo è l'editor di codice, dove scriverai il tuo programma.
Il lato destro dello schermo include una vista di esecuzione in alto e una console
in basso, dove è possibile scrivere comandi, controllare le variabili o modificarle in tempo reale
mentre il tuo programma è in esecuzione.

## Sezione Sprites

### Sprites

Clicca su **Sprites** per aprire l'editor di sprite.

:highlight #projectview .sidemenu #menuitem-sprites

:auto

## Sezione Sprites 2

:navigate projects.sprites

### Sprites

Questo è l'editor di sprites. Gli *Sprite* sono immagini che puoi disegnare qui e poi
fare riferimento al tuo codice per disegnarle sullo schermo. Clicca su uno sprite nella lista di sinistra
per aprirlo, poi usa le funzioni di disegno sul lato destro e inizia a disegnare.

## Sezione Mappe

### Mappe

Clicca su **Mappe** per aprire l'editor di mappe.

:highlight #projectview .sidemenu #menuitem-maps

:auto

## Sezione Mappe 2

:navigate projects.maps

### Mappe

Questo è l'editor di mappe. Le mappe sono spesso usate per creare livelli per i videogiochi, o per
creare ambienti che possono essere esplorati. Sono create mettendo insieme degli sprite
su una griglia. Gli sprites vengono scelti tra quelli che hai disegnato nella sezione Sprites.

Clicca su "Aggiungi mappa" per creare la tua prima mappa e inizia a disegnare sulla griglia.

## Sezione Doc

### Doc

Clicca su **Doc** per aprire l'editor di documenti.

:highlight #projectview .sidemenu #menuitem-doc

:auto

## Sezione Doc 2

:navigate projects.doc

### Doc

Questo è l'editor di doc (documentazione). Ogni volta che il tuo progetto è un plug-in che
è destinato ad essere usato da altri, o una demo per la quale si vogliono aggiungere spiegazioni,
puoi scrivere una documentazione qui usando il linguaggio markdown. Gli stessi tutorial di microStudio
sono creati con questo editor!

## Sezione impostazioni

### Opzioni

Clicca su **Opzioni** per aprire le impostazioni del progetto.

:highlight #projectview .sidemenu #menuitem-options

:auto

## Sezione Impostazioni 2

:navigate projects.options

### Opzioni

In questa sezione puoi modificare il titolo e l'URL del tuo progetto. Puoi anche
cambiare la parola segreta usata per mantenere il tuo progetto privato mentre ti permette di testarlo su
diversi dispositivi. Puoi impostare l'orientamento dello schermo più adatto al tuo progetto. Infine,
puoi invitare i tuoi amici a contribuire al tuo progetto. Tutto ciò che serve per poter inviare gli inviti è il
soprannome dei tuoi amici in microStudio.

## Pubblicare la sezione

### Pubblica

Clicca su **Pubblica** per aprire il pannello delle opzioni di pubblicazione.

:highlight #projectview .sidemenu #menuitem-publish

:auto

## Pubblica sezione 2

:navigate projects.publish

### Pubblica

Quando il vostro progetto è completo, potete renderlo pubblicamente disponibile a tutti gli utenti di microStudio.
Potete anche tenerlo privato ed esportarlo in HTML5, cioò vi permetterà di pubblicarlo
sul tuo sito web o su una piattaforma web di giochi.


## End

Questo tutorial è finito. Ora potete lanciare il tutorial "Primo progetto" per iniziare a creare
la vostra prima applicazione con microStudio.




